#include "SkPdfBoxStyleDictionary_autogen.h"


#include "SkPdfNativeDoc.h"
SkPdfArray* SkPdfBoxStyleDictionary::C(SkPdfNativeDoc* doc) {
  SkPdfNativeObject* ret = get("C", "");
  if (doc) {ret = doc->resolveReference(ret);}
  if ((ret != NULL && ret->isArray()) || (doc == NULL && ret != NULL && ret->isReference())) return (SkPdfArray*)ret;
  // TODO(edisonn): warn about missing required field, assert for known good pdfs
  return NULL;
}

bool SkPdfBoxStyleDictionary::has_C() const {
  return get("C", "") != NULL;
}

double SkPdfBoxStyleDictionary::W(SkPdfNativeDoc* doc) {
  SkPdfNativeObject* ret = get("W", "");
  if (doc) {ret = doc->resolveReference(ret);}
  if ((ret != NULL && ret->isNumber()) || (doc == NULL && ret != NULL && ret->isReference())) return ret->numberValue();
  // TODO(edisonn): warn about missing default value for optional fields
  return 0;
}

bool SkPdfBoxStyleDictionary::has_W() const {
  return get("W", "") != NULL;
}

SkString SkPdfBoxStyleDictionary::S(SkPdfNativeDoc* doc) {
  SkPdfNativeObject* ret = get("S", "");
  if (doc) {ret = doc->resolveReference(ret);}
  if ((ret != NULL && ret->isName()) || (doc == NULL && ret != NULL && ret->isReference())) return ret->nameValue2();
  // TODO(edisonn): warn about missing default value for optional fields
  return SkString();
}

bool SkPdfBoxStyleDictionary::has_S() const {
  return get("S", "") != NULL;
}

SkPdfArray* SkPdfBoxStyleDictionary::D(SkPdfNativeDoc* doc) {
  SkPdfNativeObject* ret = get("D", "");
  if (doc) {ret = doc->resolveReference(ret);}
  if ((ret != NULL && ret->isArray()) || (doc == NULL && ret != NULL && ret->isReference())) return (SkPdfArray*)ret;
  // TODO(edisonn): warn about missing default value for optional fields
  return NULL;
}

bool SkPdfBoxStyleDictionary::has_D() const {
  return get("D", "") != NULL;
}

